scala.tools.selectivecps

# SelectiveCPSTransform

#### abstract class SelectiveCPSTransform extends PluginComponent with InfoTransform with TypingTransformers with CPSUtils with TreeDSL

In methods marked @cps, CPS-transform assignments introduced by ANF-transform phase.

Linear Supertypes
TreeDSL, CPSUtils, TypingTransformers, InfoTransform, Transform, PluginComponent, SubComponent, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. SelectiveCPSTransform
2. TreeDSL
3. CPSUtils
4. TypingTransformers
5. InfoTransform
6. Transform
7. PluginComponent
8. SubComponent
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new SelectiveCPSTransform()

### Type Members

1. #### type CPSInfo = Option[(nsc.Global.Type, nsc.Global.Type)]

   Definition Classes
     CPSUtils

2. #### class CPSTransformer extends TypingTransformer

3. #### class Phase extends nsc.transform.InfoTransform.Phase

   Definition Classes
     InfoTransform → Transform

4. #### abstract class StdPhase extends GlobalPhase

   Definition Classes
     SubComponent

5. #### abstract class TypingTransformer extends nsc.Global.Transformer

   Definition Classes
     TypingTransformers

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     TreeDSL

2. #### abstract val runsAfter: List[String]

   Definition Classes
     SubComponent

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from SelectiveCPSTransform to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (SelectiveCPSTransform, B)

   Implicit information
     This member is added by an implicit conversion from SelectiveCPSTransform to ArrowAssoc[SelectiveCPSTransform] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

8. #### object CODE

   Definition Classes
     TreeDSL

9. #### lazy val Context: nsc.Global.ClassSymbol

   Definition Classes
     CPSUtils

10. #### lazy val MarkerCPSAdaptMinus: nsc.Global.ClassSymbol

    Definition Classes
      CPSUtils

11. #### lazy val MarkerCPSAdaptPlus: nsc.Global.ClassSymbol

    Definition Classes
      CPSUtils

12. #### lazy val MarkerCPSSym: nsc.Global.ClassSymbol

    Definition Classes
      CPSUtils

13. #### lazy val MarkerCPSSynth: nsc.Global.ClassSymbol

    Definition Classes
      CPSUtils

14. #### lazy val MarkerCPSTypes: nsc.Global.ClassSymbol

    Definition Classes
      CPSUtils

15. #### lazy val MethReify: nsc.Global.Symbol

    Definition Classes
      CPSUtils

16. #### lazy val MethReifyR: nsc.Global.Symbol

    Definition Classes
      CPSUtils

17. #### lazy val MethShift: nsc.Global.Symbol

    Definition Classes
      CPSUtils

18. #### lazy val MethShiftR: nsc.Global.Symbol

    Definition Classes
      CPSUtils

19. #### lazy val MethShiftUnit: nsc.Global.Symbol

    Definition Classes
      CPSUtils

20. #### lazy val MethShiftUnit0: nsc.Global.Symbol

    Definition Classes
      CPSUtils

21. #### lazy val MethShiftUnitR: nsc.Global.Symbol

    Definition Classes
      CPSUtils

22. #### lazy val ModCPS: nsc.Global.ModuleSymbol

    Definition Classes
      CPSUtils

23. #### final def afterOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

24. #### lazy val allCPSAnnotations: collection.immutable.List[nsc.Global.ClassSymbol]

    Definition Classes
      CPSUtils

25. #### def annTypes(ann: nsc.Global.AnnotationInfo): (nsc.Global.Type, nsc.Global.Type)

    Attributes
      protected
    Definition Classes
      CPSUtils

26. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

27. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

28. #### def changesBaseClasses: Boolean

    This class does not change linearization

    This class does not change linearization

    Definition Classes
      SelectiveCPSTransform → InfoTransform

29. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

30. #### var cpsEnabled: Boolean

    Definition Classes
      CPSUtils

31. #### object cpsNames

    Definition Classes
      CPSUtils

32. #### def cpsParamAnnotation(tpe: nsc.Global.Type): collection.immutable.List[nsc.Global.AnnotationInfo]

    Definition Classes
      CPSUtils

33. #### def cpsParamTypes(tpe: nsc.Global.Type): Option[(nsc.Global.Type, nsc.Global.Type)]

    Attributes
      protected
    Definition Classes
      CPSUtils

34. #### def ensuring(cond: (SelectiveCPSTransform) ⇒ Boolean, msg: ⇒ Any): SelectiveCPSTransform

    Implicit information
      This member is added by an implicit conversion from SelectiveCPSTransform to Ensuring[SelectiveCPSTransform] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

35. #### def ensuring(cond: (SelectiveCPSTransform) ⇒ Boolean): SelectiveCPSTransform

    Implicit information
      This member is added by an implicit conversion from SelectiveCPSTransform to Ensuring[SelectiveCPSTransform] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

36. #### def ensuring(cond: Boolean, msg: ⇒ Any): SelectiveCPSTransform

    Implicit information
      This member is added by an implicit conversion from SelectiveCPSTransform to Ensuring[SelectiveCPSTransform] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

37. #### def ensuring(cond: Boolean): SelectiveCPSTransform

    Implicit information
      This member is added by an implicit conversion from SelectiveCPSTransform to Ensuring[SelectiveCPSTransform] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

38. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

39. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

40. #### def filterAttribs(tpe: nsc.Global.Type, cls: nsc.Global.Symbol): collection.immutable.List[nsc.Global.AnnotationInfo]

    Definition Classes
      CPSUtils

41. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

42. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from SelectiveCPSTransform to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

43. #### def getAnswerTypeAnn(tp: nsc.Global.Type): Option[(nsc.Global.Type, nsc.Global.Type)]

    Definition Classes
      CPSUtils

44. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

45. #### def getExternalAnswerTypeAnn(tp: nsc.Global.Type): Option[(nsc.Global.Type, nsc.Global.Type)]

    Definition Classes
      CPSUtils

46. #### def hasAnswerTypeAnn(tp: nsc.Global.Type): Boolean

    Definition Classes
      CPSUtils

47. #### def hasCpsParamTypes(tpe: nsc.Global.Type): Boolean

    Attributes
      protected
    Definition Classes
      CPSUtils

48. #### def hasMinusMarker(tpe: nsc.Global.Type): Boolean

    Attributes
      protected
    Definition Classes
      CPSUtils

49. #### def hasPlusMarker(tpe: nsc.Global.Type): Boolean

    Attributes
      protected
    Definition Classes
      CPSUtils

50. #### def hasSynthMarker(tpe: nsc.Global.Type): Boolean

    Attributes
      protected
    Definition Classes
      CPSUtils

51. #### def hashCode(): Int

    Definition Classes
      SubComponent → AnyRef → Any

52. #### final val internal: Boolean(false)

    Definition Classes
      PluginComponent → SubComponent

53. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

54. #### def keepsTypeParams: Boolean

    Attributes
      protected
    Definition Classes
      InfoTransform

55. #### def linearize(a: CPSInfo, b: CPSInfo)(implicit unit: nsc.Global.CompilationUnit, pos: nsc.Global.Position): CPSInfo

    Definition Classes
      CPSUtils

56. #### def linearize(ann: List[nsc.Global.AnnotationInfo]): nsc.Global.AnnotationInfo

    Definition Classes
      CPSUtils

57. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

58. #### def newCpsParamsMarker(tp1: nsc.Global.Type, tp2: nsc.Global.Type): nsc.Global.AnnotationInfo

    Attributes
      protected
    Definition Classes
      CPSUtils

59. #### def newMarker(sym: nsc.Global.Symbol): nsc.Global.AnnotationInfo

    Attributes
      protected
    Definition Classes
      CPSUtils

60. #### def newMarker(tpe: nsc.Global.Type): nsc.Global.AnnotationInfo

    Attributes
      protected
    Definition Classes
      CPSUtils

61. #### def newMinusMarker(): nsc.Global.AnnotationInfo

    Attributes
      protected
    Definition Classes
      CPSUtils

62. #### def newPhase(prev: nsc.Phase): StdPhase

    Definition Classes
      InfoTransform → Transform → SubComponent

63. #### def newPlusMarker(): nsc.Global.AnnotationInfo

    Attributes
      protected
    Definition Classes
      CPSUtils

64. #### def newSynthMarker(): nsc.Global.AnnotationInfo

    Attributes
      protected
    Definition Classes
      CPSUtils

65. #### def newTransformer(unit: nsc.Global.CompilationUnit): nsc.Global.Transformer

    Attributes
      protected
    Definition Classes
      SelectiveCPSTransform → Transform

66. #### final def notify(): Unit

    Definition Classes
      AnyRef

67. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

68. #### def ownPhase: nsc.Phase

    Definition Classes
      SubComponent

69. #### val phaseName: String

    the following two members override abstract members in Transform

    the following two members override abstract members in Transform

    Definition Classes
      SelectiveCPSTransform → SubComponent

70. #### def phaseNewFlags: Long

    Definition Classes
      SubComponent

71. #### def phaseNextFlags: Long

    Definition Classes
      SubComponent

72. #### def removeAllCPSAnnotations(tpe: nsc.Global.Type): nsc.Global.Type

    Definition Classes
      CPSUtils

73. #### def removeAttribs(tpe: nsc.Global.Type, classes: nsc.Global.Symbol*): nsc.Global.Type

    Definition Classes
      CPSUtils

74. #### val runsBefore: List[String]

    Definition Classes
      SubComponent

75. #### val runsRightAfter: Option[String]

    Definition Classes
      PluginComponent → SubComponent

76. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

77. #### def toString(): String

    Definition Classes
      AnyRef → Any

78. #### def transformCPSType(tp: nsc.Global.Type): nsc.Global.Type

79. #### def transformInfo(sym: nsc.Global.Symbol, tp: nsc.Global.Type): nsc.Global.Type

    - return symbol's transformed type,

    - return symbol's transformed type,

    Definition Classes
      SelectiveCPSTransform → InfoTransform

80. #### def updateSynthFlag(tree: nsc.Global.Tree): nsc.Global.Tree

    Definition Classes
      CPSUtils

81. #### val verbose: Boolean

    Definition Classes
      CPSUtils

82. #### def vprintln(x: ⇒ Any): Unit

    Definition Classes
      CPSUtils

83. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

84. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

85. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

86. #### def →[B](y: B): (SelectiveCPSTransform, B)

    Implicit information
      This member is added by an implicit conversion from SelectiveCPSTransform to ArrowAssoc[SelectiveCPSTransform] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from SelectiveCPSTransform to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (selectiveCPSTransform: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from SelectiveCPSTransform to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (selectiveCPSTransform: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: SelectiveCPSTransform

   Implicit information
     This member is added by an implicit conversion from SelectiveCPSTransform to ArrowAssoc[SelectiveCPSTransform] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (selectiveCPSTransform: ArrowAssoc[SelectiveCPSTransform]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: SelectiveCPSTransform

   Implicit information
     This member is added by an implicit conversion from SelectiveCPSTransform to Ensuring[SelectiveCPSTransform] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (selectiveCPSTransform: Ensuring[SelectiveCPSTransform]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from TreeDSL

### Inherited from CPSUtils

### Inherited from TypingTransformers

### Inherited from InfoTransform

### Inherited from Transform

### Inherited from PluginComponent

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from SelectiveCPSTransform to StringAdd

### Inherited by implicit conversion any2stringfmt from SelectiveCPSTransform to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from SelectiveCPSTransform to ArrowAssoc[SelectiveCPSTransform]

### Inherited by implicit conversion any2Ensuring from SelectiveCPSTransform to Ensuring[SelectiveCPSTransform]

### Ungrouped